import { j as s } from "../../../../node_modules/react/jsx-runtime.mjs";
import { create as W, useModal as q, antdModalV5 as z } from "@ebay/nice-modal-react";
import { Modal as F, Checkbox as G } from "antd";
import t from "./index.module.less.mjs";
import { useState as H, useContext as J, useCallback as w, useMemo as v } from "react";
import { TableContext as Q } from "../../Store/Provide.mjs";
import { genColumnKey as I, columnSort as U } from "../../utils/index.mjs";
import K from "../../../../node_modules/classnames/index.mjs";
import { DndContext as X, DragOverlay as Y, defaultDropAnimationSideEffects as Z } from "../../../../node_modules/@dnd-kit/core/dist/core.esm.mjs";
import { arrayMove as _, SortableContext as $, verticalListSortingStrategy as L } from "../../../../node_modules/@dnd-kit/sortable/dist/sortable.esm.mjs";
import P from "./DndItem.mjs";
import { restrictToVerticalAxis as ee, restrictToWindowEdges as se } from "../../../../node_modules/@dnd-kit/modifiers/dist/modifiers.esm.mjs";
import E from "../../../../node_modules/lodash-es/omit.mjs";
import le from "../../../../node_modules/@ant-design/icons/es/icons/RedoOutlined.mjs";
import oe from "../../../../node_modules/@ant-design/icons/es/icons/DragOutlined.mjs";
const te = {
  sideEffects: Z({
    styles: {
      active: {
        opacity: "0.5"
      }
    }
  })
}, ye = W(() => {
  var S;
  const A = q(), [m, h] = H(null), {
    columnsMap: c,
    setColumnsMap: p,
    sortKeyColumns: y,
    setSortKeyColumns: O,
    clearPersistenceStorage: j,
    ...l
  } = J(Q), T = w(() => {
    j == null || j(), p(l.defaultColumnKeyMap);
  }, []), d = v(() => {
    var o, a;
    const e = [];
    return (o = l == null ? void 0 : l.columns) != null && o.length && ((a = l == null ? void 0 : l.columns) == null || a.map(({ key: r, dataIndex: n, ...i }) => {
      const f = I(
        r || n,
        [r || n].filter(Boolean).join("-")
      ), u = c[f || "null"];
      return u.show !== !1 && e.push({
        key: f,
        ...E(i, ["className"]),
        selectable: !1,
        disabled: u.disable === !0
      }), u;
    })), e.sort(U(c));
  }, [c, l == null ? void 0 : l.columns]), N = (e) => d.findIndex((o) => o.key === e), k = m ? N(m) : -1, C = v(() => {
    const e = [], o = /* @__PURE__ */ new Map();
    return { list: ((r, n) => r.map(({ key: i, dataIndex: f, children: u, ...M }) => {
      var D;
      const b = I(
        i || f,
        [n == null ? void 0 : n.columnKey, M.index].filter(Boolean).join("-")
      ), x = c[b || "null"] || { show: !0 };
      x.show !== !1 && !u && e.push(b);
      const g = {
        key: b,
        ...E(M, ["className"]),
        selectable: !1,
        disabled: x.disable === !0,
        disableCheckbox: typeof x.disable == "boolean" ? x.disable : (D = x.disable) == null ? void 0 : D.checkbox,
        isLeaf: n ? !0 : void 0
      };
      return o.set(i, g), g;
    }))(l == null ? void 0 : l.columns), keys: e, map: o };
  }, [c, l == null ? void 0 : l.columns]), B = (e, o) => {
    const a = { ...c };
    ((n) => {
      const i = { ...a[n] };
      i.show = !e, a[n] = i;
    })(o.key), p({ ...a });
  }, R = w(
    (e, o) => {
      {
        const a = { ...c }, r = _(y, e, o);
        r.forEach((n, i) => {
          a[n] = { ...a[n] || {}, order: i };
        }), p(a), O(r);
      }
    },
    [c, y]
  ), V = v(() => {
    var e, o;
    return m ? ((o = (e = l == null ? void 0 : l.columns) == null ? void 0 : e.find((a) => a.key === m)) == null ? void 0 : o.title) ?? "" : "";
  }, [l == null ? void 0 : l.columns, m]);
  return /* @__PURE__ */ s.jsxs(F, { title: "自定义列", ...z(A), width: 600, footer: !1, children: [
    /* @__PURE__ */ s.jsx("div", { className: t.introduce, children: "选择要在表中显示的可用列。拖动选定的列以对其重新排序。" }),
    /* @__PURE__ */ s.jsxs("div", { className: t.contaiern, children: [
      /* @__PURE__ */ s.jsxs("div", { className: t.block, children: [
        /* @__PURE__ */ s.jsxs("div", { className: t.header, children: [
          /* @__PURE__ */ s.jsx("div", { className: t.title, children: "可用列" }),
          /* @__PURE__ */ s.jsx("div", {})
        ] }),
        /* @__PURE__ */ s.jsx("div", { className: t.body, children: /* @__PURE__ */ s.jsx("ul", { className: t.content, children: (S = C.list) == null ? void 0 : S.map((e) => {
          const o = C.keys.includes(e.key);
          return /* @__PURE__ */ s.jsxs(
            "li",
            {
              className: K(t.item, {
                [t.checked]: !o
              }),
              onClick: () => !e.disabled && B(o, e),
              children: [
                /* @__PURE__ */ s.jsx(G, { checked: o, disabled: e.disabled }),
                /* @__PURE__ */ s.jsx("span", { className: t["content-item-text"], children: e.title })
              ]
            },
            e.key
          );
        }) }) })
      ] }),
      /* @__PURE__ */ s.jsxs("div", { className: t.block, children: [
        /* @__PURE__ */ s.jsxs("div", { className: t.header, children: [
          /* @__PURE__ */ s.jsx("div", { className: t.title, children: "选定的列" }),
          /* @__PURE__ */ s.jsxs("div", { className: t.reset, onClick: T, children: [
            /* @__PURE__ */ s.jsx("div", { children: "重置  " }),
            /* @__PURE__ */ s.jsx(le, {})
          ] })
        ] }),
        /* @__PURE__ */ s.jsx("div", { className: t.body, children: /* @__PURE__ */ s.jsxs(
          X,
          {
            modifiers: [ee, se],
            onDragStart: ({ active: e }) => {
              e && h(e.id);
            },
            onDragCancel: () => h(null),
            onDragEnd: (e) => {
              h(null);
              const { over: o } = e;
              if (o) {
                const a = N(o.id);
                k !== a && R(k, a);
              }
            },
            children: [
              /* @__PURE__ */ s.jsx(
                $,
                {
                  items: d == null ? void 0 : d.map((e) => e.key),
                  strategy: L,
                  children: /* @__PURE__ */ s.jsx("ul", { className: t.content, style: { background: "#fff" }, children: d == null ? void 0 : d.map((e) => /* @__PURE__ */ s.jsx(P, { item: e }, e.key)) })
                }
              ),
              /* @__PURE__ */ s.jsx(Y, { adjustScale: !1, dropAnimation: te, children: m ? /* @__PURE__ */ s.jsxs("li", { className: K(t.moveItem), children: [
                /* @__PURE__ */ s.jsx(oe, { className: t.dragIcon }),
                /* @__PURE__ */ s.jsx("span", { className: t["moveItem-text"], children: V })
              ] }) : null })
            ]
          }
        ) })
      ] })
    ] })
  ] });
});
export {
  ye as default
};
